<%- include('../partials/header') %>
<%- include('../partials/scripts') %>
<%- include('../partials/select2') %>
</head>

<body class="min-vh-100 d-flex flex-column">
	<%- include('../partials/navbar') %>
	<div class="main-content d-flex flex-column flex-grow-1">
		<%- include('../partials/topbar') %>
		<%- include('./header', { active: 'edit' }) %>
		<!-- Page content -->
		<div class="container-fluid mt--7 flex-grow-1">
			<div class="row">
				<div class="col-xl-12">
					<div class="card">
						<div class="card-header">
							<div class="row align-items-center">
								<div class="col-12">
									<h3 class="mb-0"><%= title %></h3>
								</div>
							</div>
						</div>
						<div class="card-body bg-secondary">
							<form action="./" method="POST" id="edit-result">
								<h6 class="heading text-muted mb-4">Základní údaje</h6>
								<div class="pl-lg-4">
									<div class="row">
										<div class="col">
											<div class="form-group">
												<label class="form-control-label" for="left">Levý proud</label>
												<input type="number" step="0.01" min="0.00" id="left"
													class="form-control" required
													placeholder="Vyplňte prosím toto povinné pole">
											</div>
										</div>
										<div class="col">
											<div class="form-group">
												<label class="form-control-label" for="right">Pravý proud</label>
												<input type="number" step="0.01" min="0.00" id="right"
													class="form-control" required
													placeholder="Vyplňte prosím toto povinné pole">
											</div>
										</div>
										<div class="col">
											<div class="form-group">
												<label class="form-control-label" for="final-time">
													Finální čas (0 = N / -1 = D)
												</label>
												<input type="number" step="0.01" min="0.00" id="final-time"
													class="form-control" required value="1"
													placeholder="Vyplňte prosím toto povinné pole">
											</div>
										</div>
									</div>
									<div class="row">
										<div class="col-lg-12">
											<div class="form-group">
												<label class="form-control-label" for="team">Tým</label>
												<select class="form-control" id="team"></select>
											</div>
										</div>
									</div>
									<div class="row">
										<div class="col-lg-12">
											<div class="form-group">
												<label class="form-control-label" for="yt-link">YouTube odkaz</label>
												<input type="text" id="yt-link" class="form-control"
													placeholder="Pokud existuje nějaké video, zadejte sem prosím odkaz na něj">
											</div>
										</div>
									</div>
									<div class="row">
										<div class="col-lg-6">
											<div class="form-group">
												<label class="form-control-label" for="user-type">Soutěž</label>
												<select class="form-control" id="competition"></select>
											</div>
										</div>
										<div class="col-lg-6">
											<div class="form-group">
												<label class="form-control-label" for="category">Kategorie</label>
												<select class="form-control" id="category"></select>
											</div>
										</div>
									</div>
								</div>
								<div class="pl-lg-4">
									<div class="row">
										<div class="col" id="edit-result-status" style="display: none;"></div>
										<div class="col-4 text-left">
											<button type="submit" class="btn btn-primary">Editovat</button>
										</div>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
			<%- include('../partials/footer') %>
		</div>
	</div>
	<%- include('../partials/scripts-file-end') %>
	<script>
		$(document).ready(() => {
			API.result
				.findById('<%= req.params.id %>')
				.done(function (result) {
					let $left = $('input#left')
					$left.val(result.targets.left)

					let $right = $('input#right')
					$right.val(result.targets.right)

					let $finalTime = $('input#final-time')
					$finalTime.val(result.result)

					let $youTube = $('input#yt-link')
					$youTube.val(result.media.youtube)

					API.competition
						.list()
						.done(function (competitions) {
							let $competitionSelect = $('select#competition')
							$competitionSelect.select2()
							for (let i = 0; i < competitions.length; i++) {
								$competitionSelect.append(
									$('<option>', { value: competitions[i]._id }).text(competitions[i].name)
								)
							}

							API.category
								.list()
								.done(function (categories) {
									let $categorySelect = $('select#category')
									$categorySelect.select2()
									for (let i = 0; i < categories.length; i++) {
										$categorySelect.append(
											$('<option>', { value: categories[i]._id }).text(categories[i].name)
										)
									}


									API.team
										.list()
										.done(function (teams) {
											let $teamSelect = $('select#team')
											$teamSelect.select2()
											for (let i = 0; i < teams.length; i++) {
												$teamSelect.append(
													$('<option>', { value: teams[i]._id }).text(`${teams[i].name}, okres ${teams[i].district.name.full}`)
												)
											}

											$('form#edit-result').submit(function (event) {
												event.preventDefault()
												let $status = $('div#edit-result-status')
												$status
													.empty()
													.append(
														$('<div>', { class: 'alert alert-default alert-dismissible fade show', role: 'alert' }).append(
															$('<span>', { class: 'alert-icon' }).append(
																$('<i>', { class: 'fas fa-circle-notch fa-spin' })
															),
															$('<span>', { class: 'alert-text' }).append(
																$('<strong>').text('Zpracovávám'),
																' Vyčkejte prosím'
															),
															$('<button>', { type: 'button', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'Close' }).append(
																$('<span>', { 'aria-hidden': 'true' }).html('&times;')
															)
														)
													)
													.show()

												API.result
													.edit(
														{
															id: '<%= req.params.id %>',
															targets: {
																left: $left.val(),
																right: $right.val()
															},
															finalTime: $finalTime.val(),
															team: $teamSelect.val(),
															category: $categorySelect.val(),
															competition: $competitionSelect.val(),
															media: {
																youtube: $youTube.val()
															}
														}
													)
													.done(function (responseFromServer) {
														if (responseFromServer === 'ok') {
															$status
																.empty()
																.append(
																	$('<div>', { class: 'alert alert-success alert-dismissible' }).append(
																		$('<a>', { href: '#', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'close' }).html('&times;'),
																		$('<strong>').text('Gratuluji!'),
																		' Úspěšně jste upravil(a) výsledek'
																	)
																)
																.show()

															// Reload page
															setTimeout(function () {
																window.location.href = window.location.href;
															}, 3500)
														} else {
															$status
																.empty()
																.append(
																	$('<div>', { class: 'alert alert-danger alert-dismissible' }).append(
																		$('<a>', { href: '#', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'close' }).html('&times;'),
																		$('<strong>').text('Ach ne! '),
																		responseFromServer
																	)
																)
																.show()
														}
													})
											})
										})
								})
						})
				})
		})
	</script>
	<%- include('../partials/file-end') %>